#include <SD.h> //Load SD card library
 
#include "Adafruit_GPS.h"    //Install the adafruit GPS library
#include <SoftwareSerial.h> //Load the Software Serial library
SoftwareSerial mySerial(8,7); //Initialize the Software Serial port
Adafruit_GPS GPS(&mySerial); //Create the GPS Object

/*
#include <Wire.h>
*/

/*
String NMEA1; //Variable for first NMEA sentence
char c; //to read characters coming from the GPS
float deg; //Will hold positin data in simple degree format
float degWhole; //Variable for the whole part of position 
float degDec;  //Variable for the decimal part of degree
*/

#define chipGPS 10
#define DEVICE (0x53) // Device address as specified in data sheet (accelerometer)
#define ledPin 13

/*
byte _buff[6];

This is a list of some of the registers available on the ADXL345.
To learn more about these and the rest of the registers on the ADXL345, read the datasheet!
char POWER_CTL = 0x2D;  //Power Control Register
char DATA_FORMAT = 0x31;
char DATAX0 = 0x32; //X-Axis Data 0
char DATAX1 = 0x33; //X-Axis Data 1
char DATAY0 = 0x34; //Y-Axis Data 0
char DATAY1 = 0x35; //Y-Axis Data 1
char DATAZ0 = 0x36; //Z-Axis Data 0
char DATAZ1 = 0x37; //Z-Axis Data 1

These variables will be used to hold the x,y and z axis accelerometer values.
int x,y,z;
int y;
File dataGPS; //Data object you will write your sensor data to
*/

int steps = 0;
bool stepped = false;

File ActivityFile;
//String ActivityFileName;
//int chipSelect = 10;

char filename[] = "AT_1.CSV";

/*
String GetFileName() {

  return "AT_1.csv";
    
  int i;
  String TestFile;
  for (i=1; i<200; i++) {
    TestFile = "AT_" + String(i) + ".csv";
    if (!SD.exists(TestFile)) return TestFile;
  }
  return "AT_1.csv";
}
*/

void setup() {

/*
  Wire.begin();        // join i2c bus (address optional for master)
  Serial.begin(115200); //Turn on serial monitor
*/

  GPS.begin(9600); //Turn on GPS at 9600 baud
  GPS.sendCommand(PGCMD_NOANTENNA); // Turn off updates on antenna status
  GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_RMCONLY); //Request RMC and GGA Sentences only
  GPS.sendCommand(PMTK_SET_NMEA_UPDATE_1HZ); //Set update rate to 1 hz

//  //Set up the Chip Select pin to be an output from the Arduino.
  pinMode(chipGPS, OUTPUT);
//  //Before communication starts, the Chip Select pin needs to be set high.
  digitalWrite(chipGPS, HIGH);

/*
//Put the ADXL345 into +/- 4G range by writing the value 0x01 to the DATA_FORMAT register.
  writeTo(DATA_FORMAT, 0x01);
//Put the ADXL345 into Measurement Mode by writing 0x08 to the POWER_CTL register.
  writeTo(POWER_CTL, 0x08);
*/
  
  if (!SD.begin(10)) {
    Serial.println("SDF");
  }

  
  if (SD.exists(filename)) { //Delete old data files to start fresh
    SD.remove(filename);
  }

/*
  ActivityFileName = GetFileName();
  Serial.println(ActivityFileName);
  ActivityFile = SD.open(filename, FILE_WRITE);
  
  if (!ActivityFile) {
    Serial.println("OFF");
  }
*/
  
}

int WriteCount = 0;
int Moved = 0;

int DidMove(float StartLat, float StartLon, float CurrentLat, float CurrentLon) 
{
  return 1;
  double Distance;
  Distance = sqrt(((double)CurrentLat - (double)StartLat) * ((double)CurrentLat - (double)StartLat) + ((double)CurrentLon - (double)StartLon) * ((double)CurrentLon - (double)StartLon));
  Distance = (Distance / 360.0) * 3959.0 * 2.0 * 5280.0;
/*
  ActivityFile.print("Move ");
  ActivityFile.println(Distance,8);
*/
  if (Distance > 10.0) return 1;
  return 0;
}


int Stationary(float LastLat, float LastLon, float CurrentLat, float CurrentLon) 
{
/*
  if (WriteCount > 16) return 1;
  return 0;
*/
  return 0;
  double Distance;
  Distance = sqrt(((double)CurrentLat - (double)LastLat) * ((double)CurrentLat - (double)LastLat) + ((double)CurrentLon - (double)LastLon) * ((double)CurrentLon - (double)LastLon));
  Distance = (Distance / 360.0) * 3959.0 * 2.0 * 5280.0;
/*
  ActivityFile.print("Stationary ");
  ActivityFile.println(Distance,8);
*/
  if (Distance < 6.0) return 1;
  return 0;
}


uint32_t timer = millis();


float StartLat, StartLon;
float LastLat, LastLon;
int StationaryCount = 0;

void loop() {

  if (millis() - timer > 2000) { 
    readGPS();

    if((GPS.fix==1) || (0)) { //Only save data if we have a fix 
      
      timer = millis(); //reset the timer
      WriteCount++;
      
/*
      if (NewFile) {
         if (DidMove(StartLat,StartLon,GPS.latitudeDegrees,GPS.longitudeDegrees) == 0) {
            WriteCount = 0;
            timer = millis();
            return;
         }
         NewFile = 0;
         //ActivityFileName = GetFileName();
      }
*/     

      if (WriteCount == 1) {
         StartLat = GPS.latitudeDegrees;
         StartLon = GPS.longitudeDegrees;
         LastLat = StartLat;
         LastLon = StartLon;
      }
      if (Moved == 0) Moved = DidMove(StartLat,StartLon,GPS.latitudeDegrees,GPS.longitudeDegrees);

      if (Moved != 0) {

        if (WriteCount>1) {
           if (Stationary(LastLat,LastLon,GPS.latitudeDegrees,GPS.longitudeDegrees) != 0) {
              StationaryCount++;
           }
           else {
              StationaryCount = 0;
              LastLat = GPS.latitudeDegrees;
              LastLon = GPS.longitudeDegrees;
           }
        }

         /*
         Serial.print(GPS.month);
         Serial.print("\\");
         Serial.print(GPS.day);
         Serial.print("\\");
         Serial.print(GPS.year);
         Serial.print(" ");
         Serial.print(GPS.hour);
         Serial.print(":");
         Serial.print(GPS.minute);
         Serial.print(":");
         Serial.print(GPS.seconds);
         Serial.print(",");
         Serial.print(GPS.latitudeDegrees,8);
         Serial.print(","); 
         Serial.print(GPS.longitudeDegrees,8);
         Serial.print(","); 
         Serial.println(steps);
         */

         ActivityFile = SD.open(filename, FILE_WRITE);
         ActivityFile.print(GPS.month);
         ActivityFile.print("\\");
         ActivityFile.print(GPS.day);
         ActivityFile.print("\\");
         ActivityFile.print(GPS.year);
         ActivityFile.print(" ");
         ActivityFile.print(GPS.hour);
         ActivityFile.print(":");
         ActivityFile.print(GPS.minute);
         ActivityFile.print(":");
         ActivityFile.print(GPS.seconds);
         ActivityFile.print(",");
         ActivityFile.print(GPS.latitudeDegrees,8);
         ActivityFile.print(","); 
         ActivityFile.print(GPS.longitudeDegrees,8);
         ActivityFile.print(","); 
         ActivityFile.println(steps);
         ActivityFile.close();

         if (StationaryCount == 4) {
            ActivityFile.close(); 
            while (1) { delay(1000); }
            
            //NewFile = 1;
            WriteCount = 0;
            Moved = 0;
            StartLat = GPS.latitudeDegrees;
            StartLon = GPS.longitudeDegrees;
         }
        
      } 
      
  /*        
      else {
        ActivityFile = SD.open(filename, FILE_WRITE);
        ActivityFile.println("NM");
        ActivityFile.close();
      }
 */     

    }
    /*
    timer = millis(); //reset the timer
    */
  }

/*
readAccel(); // read the x/y/z tilt

    if (y > -90 && !stepped) {
      steps++;
      stepped = true;
    }
    if (y < -90 ) {
      stepped = false;
    }
    delay(25);
    // if millis() or timer wraps around, we'll just reset it
    if (timer > millis())  timer = millis();
//  }
*/

}

void readGPS() {

String NMEA1; //Variable for first NMEA sentence
char c; //to read characters coming from the GPS
  
  clearGPS();
  while(!GPS.newNMEAreceived()) { //Loop until you have a good NMEA sentence
    c=GPS.read();
  }
  GPS.parse(GPS.lastNMEA());      //Parse that last good NMEA sentence
  NMEA1=GPS.lastNMEA();

/*
ActivityFile = SD.open(ActivityFileName, FILE_APPEND);
ActivityFile.println(NMEA1);
ActivityFile.close();
Serial.println(NMEA1);
*/

}
 
void clearGPS() {  //Clear old and corrupt data from serial port 
char c; //to read characters coming from the GPS
  
  while(!GPS.newNMEAreceived()) {  //Loop until you have a good NMEA sentence
    c=GPS.read();
  }
  GPS.parse(GPS.lastNMEA());      //Parse that last good NMEA sentence
  
  while(!GPS.newNMEAreceived()) { //Loop until you have a good NMEA sentence
    c=GPS.read();
  }
  GPS.parse(GPS.lastNMEA());      //Parse that last good NMEA sentence
   while(!GPS.newNMEAreceived()) { //Loop until you have a good NMEA sentence
    c=GPS.read();
  }
  GPS.parse(GPS.lastNMEA());      //Parse that last good NMEA sentence
  
}

/*
void readAccel() {
  uint8_t howManyBytesToRead = 6;
  //readFrom( DATAX0, howManyBytesToRead, _buff); //read the acceleration data from the ADXL345

  // each axis reading comes in 10 bit resolution, ie 2 bytes.  Least Significat Byte first!!
  // thus we are converting both bytes in to one int
  int x = (((int)_buff[1]) << 8) | _buff[0];   
  y = (((int)_buff[3]) << 8) | _buff[2];
  int z = (((int)_buff[5]) << 8) | _buff[4];
  Serial.print("x: ");
  Serial.print( x );
  Serial.print(" y: ");
  Serial.print( y );
  Serial.print(" z: ");
  Serial.println( z );
}

void writeTo(byte address, byte val) {
  Wire.beginTransmission(DEVICE);   // start transmission to device 
  Wire.write(address);              // send register address
  Wire.write(val);                  // send value to write
  Wire.endTransmission();           // end transmission
}

// Reads num bytes starting from address register on device in to _buff array
void readFrom(byte address, int num, byte _buff[]) {
  Wire.beginTransmission(DEVICE);   // start transmission to device 
  Wire.write(address);              // sends address to read from
  Wire.endTransmission();           // end transmission

  Wire.beginTransmission(DEVICE);   // start transmission to device
  Wire.requestFrom(DEVICE, num);    // request 6 bytes from device

  int i = 0;
  while(Wire.available())          // device may send less than requested (abnormal)
  { 
    _buff[i] = Wire.read();        // receive a byte
    i++;
  }
  Wire.endTransmission();          // end transmission
}
*/
